#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101
#define leave(str) {ST_helpMsg(str); push_quantum(NOTHING_TAG); return;}
#define MIN_SORTABLE_LENGTH 128
#define PROCESSED -1

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer

//Check if the ESI pointer is an integer
short is_positive_integer (ESI ptr)
{
  return (*ptr == POSINT_TAG);
}

void histogram_sort(int *data, int len)
{
	/*
 * Copyright (c) 2004 by Richard Harter.
 * This software may be freely used and modified without
 * restriction provided that this notice is preserved unaltered.
 *
 */

   int      data_min;               /* Minimum value in data array */
   int      data_max;               /* Maximum value in data array */
   int      index_min;              /* Index of minimum value      */
   int      i;                      /* Major loop index            */
   int      j;                      /* Minor loop index            */
   int      ifac;                   /* Integer scaling factor      */
   int      temp;                   /* Temp loc for data moves     */

   int      *space;                 /* Ptr to allocated space      */
   int      *cmp_index;             /* Ptr to computed indices     */
   int      *cum;                   /* Ptr to cumulative distrib.  */
   int      *hist;                  /* Ptr to cumulative distrib.  */
   int      *sorted;                /* Ptr to almost sorted data   */

   if (len <= 1) return 1;
   if (len == 2) {
      if (data[0] > data[1]) {
         temp = data[0];
         data[0] = data[1];
         data[1] = temp;
      }
      return 1;
   }
   data_min  = data[0];
   data_max  = data[0];
   index_min = 0;
   for (i=len; --i>0;) {
      if (data[i] < data_min) {
         data_min  = data[i];
         index_min = i;
      }
   }

   if (index_min != 0) {
      data[index_min] = data[0];
      data[0]         = data_min;
   }
   if (len >= MIN_SORTABLE_LENGTH) {
      for (i=len; --i>0;) {
         if (data[i] > data_max) data_max  = data[i];
      }

      /* Compute interpolation function */

      ifac = (data_max - data_min)/(len -1);
      if (ifac<=0) ifac=1;	  
      else while (((data_max-data_min)/ifac)>(len-1)) ifac++;

      /* allocate index and histogram space */

      space = malloc((2*len+1)*sizeof(int));
      if (!space) return 0;
      cmp_index = space;
      cum       = space + len;
      hist      = cum + 1;
      sorted    = hist;
      memset(cum,0,(len+1)*sizeof(int));

      /* Compute raw interpolation indices */

      for (i=len; --i>=0;) {
         hist[cmp_index[i] = (data[i] - data_min)/ifac] += 1;
      }
      for (i=1;i<len;i++) cum[i] += cum[i-1];  
      for (i=0;i<len;i++) cmp_index[i] = cum[cmp_index[i]]++;

      /* Math sort proper */

      for (i=len; --i >= 0;) sorted[cmp_index[i]] = data[i];
      memcpy(data, sorted, len*sizeof(int));
      free (space);
   }

   /* End of math sort section, begin insertion sort section */

     for (i=1; i<len; i++) {
        if (data[i] >= data[i-1]) continue;
        temp = data[i];
        data[i] = data[i-1];
        for (j = i-2; temp < data[j]; j--) data[j+1] = data[j];
        data[j+1] = temp;
     }
}

void _main(void)
{
	ESI argptr = top_estack;
	
	//Yhe first argument of the TIOS function is the length of the list
	VLI dimension = GetLongLongArg(argptr); 
	VLI i = 0;
	
	//The dynamic array
	int* array = (int*) malloc(dimension * sizeof(int));
	
	//If the second argument is a list
	if(*argptr == LIST_TAG) 
	{
		//Check if all elements of the list are integers
		//Argptr must be decremented by one to point to first element of the list
		if(!all_tail(is_positive_integer, --argptr))	
		{
			leave("List elements must be integers >= 0.");
		}
		else
			while(i<dimension && *argptr != END_TAG) array[i++]=GetLongLongArg(argptr);
	}
	
	histogram_sort(array, dimension);
	
	push_END_TAG();
	for(i=dimension; i>0; i--) push_longlongint(array[i-1]);
	push_LIST_TAG();
}